<?php


abstract class BaseSetting extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $meta;


	
	protected $description;


	
	protected $value;


	
	protected $device = 'P';


	
	protected $updated_at;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getMeta()
	{

		return $this->meta;
	}

	
	public function getDescription()
	{

		return $this->description;
	}

	
	public function getValue()
	{

		return $this->value;
	}

	
	public function getDevice()
	{

		return $this->device;
	}

	
	public function getUpdatedAt($format = 'Y-m-d H:i:s')
	{

		if ($this->updated_at === null || $this->updated_at === '') {
			return null;
		} elseif (!is_int($this->updated_at)) {
						$ts = strtotime($this->updated_at);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [updated_at] as date/time value: " . var_export($this->updated_at, true));
			}
		} else {
			$ts = $this->updated_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function setId($v)
	{


						if ($v !== null && !is_int($v) && is_numeric($v)) {

			$v = (int) $v;

		}


		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = SettingPeer::ID;
		}

	} 
	
	public function setMeta($v)
	{


						if ($v !== null && !is_string($v)) {

			$v = (string) $v; 

		}


		if ($this->meta !== $v) {
			$this->meta = $v;
			$this->modifiedColumns[] = SettingPeer::META;
		}

	} 
	
	public function setDescription($v)
	{


						if ($v !== null && !is_string($v)) {

			$v = (string) $v; 

		}


		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = SettingPeer::DESCRIPTION;
		}

	} 
	
	public function setValue($v)
	{


						if ($v !== null && !is_string($v)) {

			$v = (string) $v; 

		}


		if ($this->value !== $v) {
			$this->value = $v;
			$this->modifiedColumns[] = SettingPeer::VALUE;
		}

	} 
	
	public function setDevice($v)
	{


						if ($v !== null && !is_string($v)) {

			$v = (string) $v; 

		}


		if ($this->device !== $v || $v === 'P') {
			$this->device = $v;
			$this->modifiedColumns[] = SettingPeer::DEVICE;
		}

	} 
	
	public function setUpdatedAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [updated_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->updated_at !== $ts) {
			$this->updated_at = $ts;
			$this->modifiedColumns[] = SettingPeer::UPDATED_AT;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->meta = $rs->getString($startcol + 1);

			$this->description = $rs->getString($startcol + 2);

			$this->value = $rs->getString($startcol + 3);

			$this->device = $rs->getString($startcol + 4);

			$this->updated_at = $rs->getTimestamp($startcol + 5, null);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 6; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Setting object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(SettingPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			SettingPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
    if ($this->isModified() && !$this->isColumnModified(SettingPeer::UPDATED_AT))
    {
      $this->setUpdatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(SettingPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = SettingPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += SettingPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = SettingPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = SettingPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getMeta();
				break;
			case 2:
				return $this->getDescription();
				break;
			case 3:
				return $this->getValue();
				break;
			case 4:
				return $this->getDevice();
				break;
			case 5:
				return $this->getUpdatedAt();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = SettingPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getMeta(),
			$keys[2] => $this->getDescription(),
			$keys[3] => $this->getValue(),
			$keys[4] => $this->getDevice(),
			$keys[5] => $this->getUpdatedAt(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = SettingPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setMeta($value);
				break;
			case 2:
				$this->setDescription($value);
				break;
			case 3:
				$this->setValue($value);
				break;
			case 4:
				$this->setDevice($value);
				break;
			case 5:
				$this->setUpdatedAt($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = SettingPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setMeta($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setDescription($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setValue($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setDevice($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setUpdatedAt($arr[$keys[5]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(SettingPeer::DATABASE_NAME);

		if ($this->isColumnModified(SettingPeer::ID)) $criteria->add(SettingPeer::ID, $this->id);
		if ($this->isColumnModified(SettingPeer::META)) $criteria->add(SettingPeer::META, $this->meta);
		if ($this->isColumnModified(SettingPeer::DESCRIPTION)) $criteria->add(SettingPeer::DESCRIPTION, $this->description);
		if ($this->isColumnModified(SettingPeer::VALUE)) $criteria->add(SettingPeer::VALUE, $this->value);
		if ($this->isColumnModified(SettingPeer::DEVICE)) $criteria->add(SettingPeer::DEVICE, $this->device);
		if ($this->isColumnModified(SettingPeer::UPDATED_AT)) $criteria->add(SettingPeer::UPDATED_AT, $this->updated_at);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(SettingPeer::DATABASE_NAME);

		$criteria->add(SettingPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setMeta($this->meta);

		$copyObj->setDescription($this->description);

		$copyObj->setValue($this->value);

		$copyObj->setDevice($this->device);

		$copyObj->setUpdatedAt($this->updated_at);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new SettingPeer();
		}
		return self::$peer;
	}

} 